
#pragma once

//namespace MINITLIB{

#include <atlctrls.h>

template <class T, class TBase = CReBarCtrl, class TWinTraits = CControlWinTraits>
class ATL_NO_VTABLE CReBarCtrlImpl : public CWindowImpl< T, TBase, TWinTraits >
{
public:


	// Overrides
	void OnRefreshBackGround()
	{
	}

	BEGIN_MSG_MAP(CReBarCtrlImpl)
		//MESSAGE_HANDLER(WM_PAINT, OnPaint)
		//MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackGround)
		MESSAGE_HANDLER(WM_SIZE,OnSize)
		
	END_MSG_MAP()

	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		bHandled = FALSE;
		T* pT = static_cast<T*>(this);
		pT->OnRefreshBackGround();

		
		return 0;
	}

};


class CDonutReBarCtrl : public CReBarCtrlImpl<CDonutReBarCtrl>
{
public:
	CBitmap m_bmpBack;
	CBitmap m_bmpStretch;
	int m_nBGStyle;

	CDonutReBarCtrl() : m_nBGStyle(0)
	{
	}


	// Overrides
	void OnRefreshBackGround()
	{
		if(m_nBGStyle == SKN_REBAR_STYLE_STRETCH){
			CRect rc;
			GetClientRect(&rc);
			
			HDC hDesktopDC = ::GetDC(NULL);
			CDC dcSrc, dcDest;
			dcDest.CreateCompatibleDC(hDesktopDC);
			dcSrc.CreateCompatibleDC(hDesktopDC);
			if(m_bmpStretch.m_hBitmap) m_bmpStretch.DeleteObject();
			m_bmpStretch.CreateCompatibleBitmap(hDesktopDC,rc.Width(),rc.Height());

			HBITMAP hOldbmpSrc = dcSrc.SelectBitmap(m_bmpBack.m_hBitmap);
			HBITMAP hOldbmpDest = dcDest.SelectBitmap(m_bmpStretch.m_hBitmap);

			SIZE size;
			m_bmpBack.GetSize(size);
			::StretchBlt(dcDest,0,0,rc.Width(),rc.Height(),
			             dcSrc ,0,0,size.cx,size.cy,SRCCOPY);

			dcSrc.SelectBitmap(hOldbmpSrc);
			dcDest.SelectBitmap(hOldbmpDest);

			_SetBackGround(m_bmpStretch);

			InvalidateRect(NULL,TRUE);
		}
	}

	//Function
	void _SetDrawStyle(int nStyle)
	{
		m_nBGStyle = nStyle;
		CTheme theme;
		if(nStyle == SKN_REBAR_STYLE_THEME)
			theme.SetWindowTheme(m_hWnd, NULL, L"REBAR");
		else
			theme.SetWindowTheme(m_hWnd, L" ", L" ");
	}

	void _SetBackGround(HBITMAP hBitmap)
	{
		REBARBANDINFO rbbi = { sizeof(REBARBANDINFO) };
		rbbi.fMask = RBBIM_BACKGROUND;
		rbbi.hbmBack = hBitmap;

		int nCount = GetBandCount();
		for (int i=0; i<nCount; i++)
			SetBandInfo(i,&rbbi);
	}

	void _SetBoader(BOOL bShow)
	{
		int nStyle = GetWindowLong(GWL_STYLE);
		if(bShow)
			nStyle |= RBS_BANDBORDERS;
		else
			nStyle &= ~RBS_BANDBORDERS;
		SetWindowLong(GWL_STYLE,nStyle);
	}

	void RefreshSkinState()
	{
		//wi`@̐ݒ
		_SetDrawStyle(CSkinOption::s_nRebarBGStyle);
		CString strBmpPath = _GetSkinDir() + _T("rebar.bmp");

		//wĩrbg}bvǂݍ
		m_bmpBack.Attach(AtlLoadBitmapImage(strBmpPath.GetBuffer(0), LR_LOADFROMFILE));
		if(m_nBGStyle == SKN_REBAR_STYLE_TILE) _SetBackGround(m_bmpBack);
		OnRefreshBackGround();

		//E̐ݒ
		_SetBoader(!(BOOL)CSkinOption::s_nRebarNoBoader);

		//ĕ`
		InvalidateRect(NULL,TRUE);
	}

};


class CTransparentToolBarCtrl : public CWindowImpl<CTransparentToolBarCtrl,CToolBarCtrl>
{
public:
	BEGIN_MSG_MAP(CTransparentToolBarCtrl)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackGround)
	END_MSG_MAP()

	LRESULT OnEraseBackGround(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		HWND hWnd = GetParent();
		CPoint pt(0, 0);
		MapWindowPoints(hWnd, &pt, 1);
		pt = ::OffsetWindowOrgEx((HDC)wParam, pt.x, pt.y, NULL);
		LRESULT lResult = ::SendMessage(hWnd, WM_ERASEBKGND, wParam, 0L);
		::SetWindowOrgEx((HDC)wParam, pt.x, pt.y, NULL);
		return lResult;
	}
};

class CDonutExplorerReBarCtrl : public CDonutReBarCtrl
{
public:

	CDonutExplorerReBarCtrl& operator=(HWND hWnd)
	{
		m_hWnd = hWnd;
		return *this;
	}


	BEGIN_MSG_MAP(CTransparentToolBarCtrl)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackGround)
	END_MSG_MAP()

	LRESULT OnEraseBackGround(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		HWND hWnd = GetParent();
		CPoint pt(0, 0);
		MapWindowPoints(hWnd, &pt, 1);
		pt = ::OffsetWindowOrgEx((HDC)wParam, pt.x, pt.y, NULL);
		LRESULT lResult = ::SendMessage(hWnd, WM_ERASEBKGND, wParam, 0L);
		::SetWindowOrgEx((HDC)wParam, pt.x, pt.y, NULL);
		return lResult;
	}
};

//}; //namespace MINITLIB